#ifndef HEADER_DH_H
#include <openssl/dh.h>
#endif
DH *get_dh512()
	{
	static unsigned char dh512_p[]={
		0xDD,0x0A,0x58,0xAD,0x91,0xB0,0x2F,0x9B,0x3A,0x33,0x98,0xAB,
		0x50,0x94,0x69,0x5C,0x7A,0x22,0xF9,0x35,0xA9,0x41,0x48,0x68,
		0xD9,0xC9,0xE0,0xA8,0xF2,0x61,0xE2,0xC6,0x58,0x4A,0xB3,0xD0,
		0xE0,0x0A,0x2E,0x87,0xF0,0x1E,0x67,0x89,0x58,0xD9,0xA7,0xDD,
		0x28,0x27,0x6B,0x36,0x13,0x44,0xB1,0x67,0x77,0x14,0x85,0x25,
		0x87,0xC4,0xA7,0xEB,
		};
	static unsigned char dh512_g[]={
		0x02,
		};
	DH *dh;

	if ((dh=DH_new()) == NULL) return(NULL);
	dh->p=BN_bin2bn(dh512_p,sizeof(dh512_p),NULL);
	dh->g=BN_bin2bn(dh512_g,sizeof(dh512_g),NULL);
	if ((dh->p == NULL) || (dh->g == NULL))
		{ DH_free(dh); return(NULL); }
	return(dh);
	}
